package com.loit.seata.order.example;

import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.Banner;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.openfeign.EnableFeignClients;

@EnableDiscoveryClient
@EnableFeignClients
@SpringBootApplication(scanBasePackages = {"com.loit.seata"}, exclude = DataSourceAutoConfiguration.class)
@Slf4j
public class LoitSeataOrderExampleApplication {

    public static void main(String[] args) {
        log.info("start execute LoitSeataOrderExampleApplication....\n");
        System.out.println("start execute LoitSeataOrderExampleApplication....\n");
        new SpringApplicationBuilder(LoitSeataOrderExampleApplication.class).bannerMode(Banner.Mode.OFF).run(args);
        System.out.println("end execute LoitSeataOrderExampleApplication....\n");
        log.info("end execute LoitSeataOrderExampleApplication....\n");
    }

}
